function kfet_open(init_date, init_satus, init_force_close, force_close_url, force_open_url) {
    // VARIABLES
    var kfet_open_bullet = $('#kfet-open');
    var open_status = $('#open_status');
    var force_close_button = $('#force_close_button');
    // bullet
    var open_color = "#73C252";
    var closed_color = "#B42B26";
    var unknown_color = "#ECD03E";
    // status bar
    var open_color_status = "#73C252";
    var closed_color_status = "#B42B26";
    var unknown_color_status = "#D4BE4C";

    var kfet_open_date = init_date;
    var kfet_open = init_status; 
    var force_close = init_force_close;
    
    // EVENT
    force_close_button.click(forceClose);

    // INITIALISAITION
    update_open();
    update_force_button();

    // On recherge toute les 30sec 
    // (dans le cas où le statut deviendrait inconn)
    setInterval(function() {
        update_open();
    }, 30 * 1000); // 60 * 1000 milsec	

    // FONCTIONS
    function forceClose(password = '') {
        if (force_close) {
            force_url = force_open_url;
        } else {
            force_url = force_close_url;
        }
        $.ajax({
            dataType: "html",
            url     : force_url,
            method  : "GET",
            beforeSend: function ($xhr) {
                if (password != '')
                    $xhr.setRequestHeader("KFetPassword", password);
            },
        })
        .done(function() {})
        .fail(function($xhr) {
            var data = $xhr.responseJSON;
            switch ($xhr.status) {
                case 403:
                    requestAuth({'errors':{}}, forceClose);
                    break;
                case 400:
                    alert('lol');
                    break;
            }
            lock = 0;
        });
    }

    function nb_min_diff() {
        var date_now = new Date();
        // On calcule le nb de minutes depuis le dernier
        // envoi d'information
        tmp = date_now - kfet_open_date;

        tmp = Math.floor(tmp/1000);             // Nombre de secondes entre les 2 dates
        diff_sec = tmp % 60;                    // Extraction du nombre de secondes

        tmp = Math.floor((tmp-diff_sec)/60);    // Nombre de minutes (partie entière)
        
        return tmp;
    }
    function do_kfet_close() {
        kfet_open_bullet.css({'background-color': closed_color});
        open_status.parent().css({'background-color': closed_color_status});
        open_status.html("FERMÉE");
    }
    function do_kfet_open() {
        kfet_open_bullet.css({'background-color': open_color});
        open_status.parent().css({'background-color': open_color_status});
        open_status.html("OUVERTE");
    }
    function do_kfet_unknown() {
        kfet_open_bullet.css({'background-color': unknown_color});
        open_status.parent().css({'background-color': unknown_color_status});
        open_status.html("?????");
    }
    function update_open() {
        nb_min = nb_min_diff();
        console.log("K-Fêt ouverte : " + (kfet_open&&(!force_close)));
        console.log(nb_min + " minute(s) depuis la dernière mise à jour");
        if (force_close) {
            do_kfet_close();
        } else {
            if (nb_min > 15) {
                do_kfet_unknown();
            } else if (kfet_open){
                do_kfet_open();
            } else {
                do_kfet_close();
            }
        }
    }
    function update_force_button() {
        if (force_close) {
            force_close_button.html('Réouvrir la K-Fêt');
        } else {
            force_close_button.html('Fermer manuellement');
        }
    }
    // SYNCHRONIZATION
    websocket_msg_default = {'last_op': 0}

    var websocket_protocol = window.location.protocol == 'https:' ? 'wss' : 'ws';
    var location_host = window.location.host;
    var location_url = window.location.pathname.startsWith('/gestion/') ? location_host + '/gestion' : location_host;
    var socket = new ReconnectingWebSocket(websocket_protocol+"://" + location_url + "/ws/k-fet/is_open/");

    socket.onmessage = function(e) {
        var data = $.extend({}, websocket_msg_default, JSON.parse(e.data));

        if (data['door_action']) {
            console.log("* Message reçu de la part de la porte.");

            kfet_open_date = new Date(data['door_action']['kfet_open_date']);
            kfet_open = data['door_action']['kfet_open'];

            update_open();
        }
        if (data['force_action']) {
            force_close = data['force_action']['force_close'];
            console.log("* Message reçu de la part d'un-e utilisat-rice-eur. Close = " + force_close);

            update_open();
            update_force_button();
        }
    }
}
